{{- if (not .Values.config.postgres.integration) }}
apiVersion: batch/v1
kind: Job
metadata:
  name: {{ .Release.Name }}-db-roles-{{ now | unixEpoch }}
  namespace: {{ .Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ template "supabase.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
spec:
  backoffLimit: 6
  ttlSecondsAfterFinished: 100
  template:
    spec:
      containers:
      - name: db-roles
        image: postgres:15-alpine
        command:
          - /bin/sh
          - -c
          - |
            timeout 60 bash -c 'until PGPASSWORD="${POSTGRES_PASSWORD}" psql -h "${POSTGRES_HOST}" -p "${POSTGRES_PORT}" -U "${POSTGRES_USER}" -d "${POSTGRES_DATABASE}" -c "\q"; do
              echo "Waiting for database to be ready..."
              sleep 2
            done'
            PGPASSWORD="${POSTGRES_PASSWORD}" psql -v ON_ERROR_STOP=1 -h "${POSTGRES_HOST}" -p "${POSTGRES_PORT}" -U "${POSTGRES_USER}" -d "${POSTGRES_DATABASE}" <<'EOSQL'
            BEGIN;
            DROP ROLE IF EXISTS ${POSTGRES_ROLE_AUTHENTICATOR};
            CREATE SCHEMA IF NOT EXISTS realtime;
            CREATE SCHEMA IF NOT EXISTS auth AUTHORIZATION ${POSTGRES_USER};
            CREATE SCHEMA IF NOT EXISTS storage AUTHORIZATION ${POSTGRES_USER};
            ALTER ROLE ${POSTGRES_USER} SET search_path TO "\$user",public,extensions;
            ALTER ROLE ${POSTGRES_ROLE_AUTHENTICATOR} INHERIT;
            ALTER ROLE ${POSTGRES_ROLE_AUTHENTICATOR} SUPERUSER;
            COMMIT;
            EOSQL
            for f in /tmp/initdb.d/*.sql; do
              echo "Running $f";
              PGPASSWORD="${POSTGRES_PASSWORD}" psql -v ON_ERROR_STOP=1 -h "${POSTGRES_HOST}" -p "${POSTGRES_PORT}" -U "${POSTGRES_USER}" -d "${POSTGRES_DATABASE}" -f "$f"
            done
        env:
          - name: POSTGRES_HOST
            value: {{ .Values.config.postgres.host | quote }}
          - name: POSTGRES_PORT
            value: {{ .Values.config.postgres.port | quote }}
          - name: POSTGRES_ROLE_ANON
            value: {{ .Values.config.postgres.roles.anon | quote }}
          - name: POSTGRES_ROLE_AUTH
            value: {{ .Values.config.postgres.roles.auth | quote }}
          - name: POSTGRES_ROLE_AUTHENTICATOR
            value: {{ .Values.config.postgres.roles.authenticator | quote }}
          - name: POSTGRES_ROLE_FUNCTIONS
            value: {{ .Values.config.postgres.roles.functions | quote }}
          - name: POSTGRES_ROLE_STORAGE
            value: {{ .Values.config.postgres.roles.storage | quote }}
          - name: POSTGRES_DATABASE
            valueFrom:
              secretKeyRef:
                name: {{ template "supabase.name" . }}-postgres
                key: database
          - name: POSTGRES_USER
            valueFrom:
              secretKeyRef:
                name: {{ template "supabase.name" . }}-postgres
                key: username
          - name: POSTGRES_PASSWORD
            valueFrom:
              secretKeyRef:
                name: {{ template "supabase.name" . }}-postgres
                key: password
          - name: POSTGRES_ROLE_AUTHENTICATOR
            value: {{ .Values.config.postgres.roles.authenticator | quote }}
          - name: JWT_SECRET
            valueFrom:
              secretKeyRef:
                name: {{ template "supabase.name" . }}-auth
                key: jwt-secret
          - name: JWT_EXP
            value: "3600"
        volumeMounts:
          - name: initdb
            mountPath: /tmp/initdb.d
      restartPolicy: OnFailure
      volumes:
        - name: initdb
          configMap:
            name: initdb
{{- end }}
